/*Roventa Robert
 *Grupa 334CC
 * Materia: Proiectarea cu Microprocesoare
 * Proiect "Joc X si 0"
 * Asistent: Ioan Deaconu
 */

#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>
#include <stdlib.h>

#define MAX_ITERATION 1000000
#define MAX_NEG -10
/* 

	
	--------------------------------
	
	Matrice red
	
	PA7 PA5 PA3
	
	PA1 PB0 PC6
	
	PC5 PC3 PC1
	
	--------------------------------
	Matrice green
	
	PA6 PA4 PA2
	
	PA0 PB1 PC7
	
	PC4 PC2 PC0	
	------------------------------
	
	Matrice leduri
	
	(PA7-red PA6-green) (PA5-red PA4-green) (PA3-red PA2-green)
	
	(PA1-red PA0-green) (PB1-green PB0-red) (PC7-green PC6-red)
	
	(PC5-red PC4-green) (PC3-red PC2-green) (PC1-red PC0-green)
	
	------------------------------
	
	
	Pini pentru butoane:
	
	PB2 - btn. jos
	PB3 - btn. stanga

	PD0 - btn. centru
	PD1 - btn. dreapta
	PD4 - btn. sus
	
	-------------------------------
	
	*/
typedef struct _full_pin {
	int pin;
	int port;
} PINI;

typedef struct _win_details {
	int winner;
	int line;
	int col;
	int diag;
	int equal;

} _WINNER;

// Corespondenta matrice cu pini de pe microcontroller
PINI check_led(int line, int col,int next_move) {
	
	PINI to_ret;
	
	//Red
	if ((line == 2) && (col == 0) && ((next_move % 2) == 0)) {
		to_ret.pin = PC5;
		to_ret.port = 3;
		return to_ret;
	}
	
	if ((line == 2) && (col == 1) && ((next_move % 2) == 0)) {
		to_ret.pin = PC3;
		to_ret.port = 3;
		return to_ret;
	}
	
	if ((line == 2) && (col == 2) && ((next_move % 2) == 0)) {
		to_ret.pin = PC1;
		to_ret.port = 3;
		return to_ret;
	}
	
	if ((line == 0) && (col == 0) && ((next_move % 2) == 0)) {
		to_ret.pin = PA7;
		to_ret.port = 1;
		return to_ret;
	} 
	
	if ((line == 0) && (col == 1) && ((next_move % 2) == 0)) {
		to_ret.pin = PA5;
		to_ret.port = 1;
		return to_ret;
	}
	
	if ((line == 0) && (col == 2) && ((next_move % 2) == 0)) {
		to_ret.pin = PA3;
		to_ret.port = 1;
		return to_ret;
	}
	
	if ((line == 1) && (col == 0) && ((next_move % 2) == 0)) {
		to_ret.pin = PA1;
		to_ret.port = 1;
		return to_ret;
	}
	
	
	if ((line == 1) && (col == 1) && ((next_move % 2) == 0)) {
		to_ret.pin = PB0;
		to_ret.port = 2;
		return to_ret;
	}
	
	if ((line == 1) && (col == 2) && ((next_move % 2) == 0)) {
		to_ret.pin = PC6;
		to_ret.port = 3;
		return to_ret;
	}
	
	
	
	//Green
	
	if ((line == 0) && (col == 0) && ((next_move % 2) == 1)) {
		to_ret.pin = PA6;
		to_ret.port = 1;
		return to_ret;
	} 
	
	if ((line == 0) && (col == 1) && ((next_move % 2) == 1)) {
		to_ret.pin = PA4;
		to_ret.port = 1;
		return to_ret;
	} 
	
	if ((line == 0) && (col == 2) && ((next_move % 2) == 1)) {
		to_ret.pin = PA2;
		to_ret.port = 1;
		return to_ret;
	} 
	
	if ((line == 1) && (col == 0) && ((next_move % 2) == 1)) {
		to_ret.pin = PA0;
		to_ret.port = 1;
		return to_ret;
	} 
	
	if ((line == 1) && (col == 1) && ((next_move % 2) == 1)) {
		to_ret.pin = PB1;
		to_ret.port = 2;
		return to_ret;
	} 
	
	if ((line == 1) && (col == 2) && ((next_move % 2) == 1)) {
		to_ret.pin = PC7;
		to_ret.port = 3;
		return to_ret;
	} 
	
	if ((line == 2) && (col == 0) && ((next_move % 2) == 1)) {
		to_ret.pin = PC4;
		to_ret.port = 3;
		return to_ret;
	} 
	
	if ((line == 2) && (col == 1) && ((next_move % 2) == 1)) {
		to_ret.pin = PC2;
		to_ret.port = 3;
		return to_ret;
	} 
	
	if ((line == 2) && (col == 2) && ((next_move % 2) == 1)) {
		to_ret.pin = PC0;
		to_ret.port = 3;
		return to_ret;
	} 
	
	to_ret.pin = -1;
	to_ret.port = -1;
	return to_ret;

}

// Inversam startea ledului
void led_light(PINI ret_pd) {

if (ret_pd.port == 1) {
		PORTA ^= ( 1 << ret_pd.pin);
	}
	else {
		if (ret_pd.port == 2) {
			PORTB ^= ( 1 << ret_pd.pin);
		}
		else {
			if (ret_pd.port == 3) {
				PORTC ^= ( 1 << ret_pd.pin);
			}
		}
	}

}

// Verificam daca avem castigator
_WINNER check_win(int mat_led[3][3]) {

	int once = 0;
	int i, j;
	_WINNER aux;
	int win_red, win_green, win_red_col, win_green_col;
	int win_red_diag, win_green_diag;
	
	aux.winner = 0;
	aux.line = -10;
	aux.col = -10;
	aux.diag = -10;
	aux.equal = 0;
	
	// Verificam liniile si coloanele
	for (i = 0; i < 3; i++) {
		win_red = 0;
		win_green = 0;
		win_red_col = 0;
		win_green_col = 0;
		for (j = 0; j < 3; j++) {
		
			if ((mat_led[i][j] == 2) || (mat_led[i][j] == 0)) {
				win_red = 1;
			}
			
			if ((mat_led[i][j] == 1) || (mat_led[i][j] == 0)) {
				win_green = 1;
			}
			
			if ((mat_led[j][i] == 2) || (mat_led[j][i] == 0)) {
				win_red_col = 1;
			}
			
			if ((mat_led[j][i] == 1) || (mat_led[j][i] == 0)) {
				win_green_col = 1;
			}
		}
		
		if (win_red == 0) {
			aux.winner = 1;
			aux.line = i;
			return aux;
		}
		
		if (win_green == 0) {
			aux.winner = 2;
			aux.line = i;
			return aux;
		}
		
		if (win_green_col == 0) {
			aux.winner = 2;
			aux.col = i;
			return aux;
		}
		
		if (win_red_col == 0) {
			aux.winner = 1;
			aux.col = i;
			return aux;
		}
	}
	

	// Verific diagonala principala
	win_red_diag = 0;
	win_green_diag = 0;
	for (i = 0; i  < 3; i++) {
		if ((mat_led[i][i] == 2) || (mat_led[i][i] == 0)) {
			win_red_diag = 1;
		}
		
		if ((mat_led[i][i] == 1) || (mat_led[i][i] == 0)) {
			win_green_diag = 1;
		}
	}
	
	if (win_red_diag == 0) {
		aux.winner = 1;
		aux.diag = 100;
		return aux;
	}
	
	if (win_green_diag == 0) {
		aux.winner = 2;
		aux.diag = 100;
		return aux;
	}
	
	// Verific diagonala secundara
	win_red_diag = 0;
	win_green_diag = 0;
	for (i = 0; i  < 3; i++) {
		if ((mat_led[i][3-i-1] == 2) || (mat_led[i][3-i-1] == 0)) {
			win_red_diag = 1;
		}
		
		if ((mat_led[i][3-i-1] == 1) || (mat_led[i][3-i-1] == 0)) {
			win_green_diag = 1;
		}
	}
	
	if (win_red_diag == 0) {
		aux.winner = 1;
		aux.diag = 200;
		return aux;
	}
	
	if (win_green_diag == 0) {
		aux.winner = 2;
		aux.diag = 200;
		return aux;
	}	
	
	
	// Verificam daca a fost egalitate
	for (i = 0; i < 3; i++) {
		for (j = 0; j < 3; j++) {
			if ((mat_led[i][j] == 0) && (once == 0)) {
				once = 1;
			}
		}
	}
	
	if (once == 0) {
		
		aux.winner = 3;
		aux.line = -10;
		aux.col = -10;
		aux.diag = -10;
		aux.equal = 1;
		return aux;
	}
		
	
	
	aux.winner = 0;
	aux.line = -10;
	aux.col = -10;
	aux.diag = -10;
	aux.equal = 0;
	return aux;
	

}

int main(){
	
	
	// Setăm toti pinii portului A, B, C si D că pini de iesire
	DDRB = 0xFF;
	DDRA = 0xFF;
	DDRC = 0xFF;
	DDRD = 0xFF;
	
	/* Pentru butoane test */
	
	// Buton sus
	 DDRD &= ~(1 << PD4);  // pinul PD4 va fi input
	 PORTD |= (1 << PD4);  // activam rezistenta de pull-up
	 
	 // Buton stanga
	 DDRB &= ~(1 << PB3);  // pinul PB3 va fi input
	 PORTB |= (1 << PB3);  // activam rezistenta de pull-up
	 
	 // Buton dreapta
	 DDRD &= ~(1 << PD1);  // pinul PD1 va fi input
	 PORTD |= (1 << PD1);  // activam rezistenta de pull-up
	 
	  // Buton centru
	 DDRD &= ~(1 << PD0);  // pinul PD0 va fi input
	 PORTD |= (1 << PD0);  // activam rezistenta de pull-up
	 
	 // Buton jos
	 DDRB &= ~(1 << PB2);  // pinul PB3 va fi input
	 PORTB |= (1 << PB2);  // activam rezistenta de pull-up
	 
	
	
	
	int i, j;
	int mat_led[3][3];
	int next_move = 0;
	int line = 0, col = 0;
	int once = 0;
	_WINNER winner;
	PINI ret_pd;
	
	
	
	// Initializare structura winner
	winner.winner = 0;
	winner.line = -10;
	winner.col = -10;
	winner.diag = -10;
	winner.equal = 0;
	
	// Initializare matrice de leduri
	for (i = 0; i < 3; i++) {
		for (j = 0; j < 3; j++) {
			mat_led[i][j] = 0;
		}
	}
	
	// Mod joc default
	PORTD ^= ( 1 << PD7);
	
	
	while(1) {
	
		line = 0;
		col = 0;
		once = 0;
		
		if (winner.winner != 0) {
			break;
		}
		
		// Verificam led liber
		for (i = 0; i < 3; i++) {
			for (j = 0; j < 3; j++) {
				if ((mat_led[i][j] == 0) && (once == 0)) {
					line = i;
					col = j;
					once = 1;
				}
			}
		}
		
		// Determinam pinul cu ledul liber
		ret_pd = check_led (line, col, next_move);
		
		// Aprindem ledul
		led_light(ret_pd);
		
		_delay_ms(500);
		
		
			// Miscare stanga, dreapta, sus, jos, selectie
			while (1) {
				
				
				// Buton dreapta
				if (!(PIND & (1 << PD1))) {
					
						// Stingem ledul de unde a venit
						led_light(ret_pd);
						
						// Iteram in dreapta pana gasim un led neaprins
						do {
						
						// "Urcam" o line
						if (col == 2) {
							line = (line + 1) % 3;
						}
						
						// "Urcam" o coloana
						col = (col + 1) % 3;
						
						} while (mat_led[line][col] != 0);
						
						// Aprind noul led
						ret_pd = check_led (line, col, next_move);
						led_light(ret_pd);
						
						_delay_ms(500);
				}
				
				// Buton stanga
				if (!(PINB & (1 << PB3))) {
				
					
						// Stingem ledul de unde a venit
						led_light(ret_pd);
						
						
						// Iteram in stanga pana gasim un led neaprins
						do {
						// "Coboram" o linie
						if (col == 0) {
							line = line - 1;
							if (line < 0) line = 2;
							line= line % 3;
						}
						
						// "Coboram" o coloana
						col = col - 1;
						if (col < 0) col = 2;
						col = col % 3;
						
						} while (mat_led[line][col] != 0);
						
						// Aprind noul led
						ret_pd = check_led (line, col, next_move);
						led_light(ret_pd);
						
						_delay_ms(500);
				}
				
				// Buton sus
				 if (!(PIND & (1 << PD4))) {
					
						// Stingem ledul de unde a venit
						led_light(ret_pd);
						
						// Iteram in sus pana gasim un led neaprins
						do {
						
						// "Coboram" o coloana
						if (line == 0) {
							col = col - 1;
							if (col < 0) col = 2;
							col = col % 3;
						}
						
						// "Coboram" o linie
						line = line - 1;
						if (line < 0) line = 2;
						line = line % 3;
						
						} while (mat_led[line][col] != 0);
						
						// Aprind noul led
						ret_pd = check_led (line, col, next_move);
						led_light(ret_pd);
						
						_delay_ms(500);
					
				 }
				 
				 // Buton jos
				 if (!(PINB & (1 << PB2))) {
				 
						// Stingem ledul de unde a venit
						led_light(ret_pd);
						
						// Iteram in jos pana gasim un led neaprins
						do {
						
						// "Urcam" o coloana
						if (line == 2) {
							col = (col + 1) % 3;
						}
						
						// "Urcam" o linie
						line = (line + 1) % 3;
						
						} while (mat_led[line][col] != 0);
						
						// Aprindem noul led
						ret_pd = check_led (line, col, next_move);
						led_light(ret_pd);
						
						_delay_ms(500);
				 }
				
				// Buton centru
				if (!(PIND & (1 << PD0))) {
					
					// Selectie led pentru jucator red
					if ((next_move % 2) == 0) {
						mat_led[line][col] = 1;
					}
					// Selectie led pentru jucator green
					else {
						mat_led[line][col] = 2;
					}
					
					winner = check_win(mat_led);
					
					next_move++;
					break;
				}
				
			}
		}
	
	
	// Felicitam castigatorul
	while (1) {
	
		next_move = winner.winner;
		
		// Daca s-a completat o linie
		if (winner.line != -10) {
		
			for (i = 0; i < 3; i++) {
				ret_pd = check_led (winner.line, i, next_move);
				led_light(ret_pd);
				
			}
			
			_delay_ms(500);
			
			for (i = 0; i < 3; i++) {
				ret_pd = check_led (winner.line, i, next_move);
				led_light(ret_pd);
				
			}
			
			_delay_ms(500);
		
		}
		
		// Daca s-a completat o coloana
		if (winner.col != -10) {
		
			for (i = 0; i < 3; i++) {
				ret_pd = check_led (i, winner.col, next_move);
				led_light(ret_pd);
				
			}
			
			_delay_ms(500);
			
			for (i = 0; i < 3; i++) {
				ret_pd = check_led (i, winner.col, next_move);
				led_light(ret_pd);
				
			}
			
			_delay_ms(500);
		
		}
		
		// Daca s-a completat diagonala principala
		if (winner.diag == 100) {
			for (i = 0; i < 3; i++) {
				ret_pd = check_led (i, i, next_move);
				led_light(ret_pd);
			}	
			_delay_ms(500);
				
			for (i = 0; i < 3; i++) {
				ret_pd = check_led (i, i, next_move);
				led_light(ret_pd);
			}	
			_delay_ms(500);
		}
		
		// Daca s-a completat diagonala secundara
		if (winner.diag == 200) {
			for (i = 0; i < 3; i++) {
				ret_pd = check_led (i, 3-i-1, next_move);
				led_light(ret_pd);
			}	
			_delay_ms(500);
				
			for (i = 0; i < 3; i++) {
				ret_pd = check_led (i, 3-i-1, next_move);
				led_light(ret_pd);
			}	
			_delay_ms(500);
		}
		
		// Egalitate
		if (winner.equal == 1) {
		
			//Start red PORT A
			for (i = 7; i >= 0; i=i-2) {
				PORTA = PORTA ^ (1 << i);	// inversăm starea ledului
			}
			
			//Start red PORT C
			for (i = 5; i >= 0; i=i-2) {
				PORTC = PORTC ^ (1 << i);	// inversăm starea ledului
			}	
			PORTC = PORTC ^ ( 1 << PC6);
			
			//Start red PORT B
			PORTB = PORTB ^ (1 << PB0);	// inversăm starea ledului
		
			
			_delay_ms(500);
			
			//Stop red port A
			for (i = 7; i >= 0; i=i-2) {
				PORTA = PORTA ^ (1 << i);	// inversăm starea ledului
			}
			
			// Stop red port C
			for (i = 5; i >= 0; i=i-2) {
				PORTC = PORTC ^ (1 << i);	// inversăm starea ledului
			}
			PORTC = PORTC ^ ( 1 << PC6);
			
			//Stop red port B
			PORTB = PORTB ^ (1 << PB0);	// inversăm starea ledului
			
			_delay_ms(500);
		
		}
	}
	
	
	return 0;
}